// ! form input check
var NUM = "0123456789";	
var SALPHA = "abcdefghijklmnopqrstuvwxyz";
var ALPHA = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"+SALPHA;
var EMAIL = "!#$%&*+-./=?@^_`{|}"+NUM+ALPHA;
var PASSWORD = "!@.#,$%^*&_-" + ALPHA + NUM;
var ERRORMSG = "";

var BPROCESSING = 0;

function StringSize (s) {
	var i;
	var len = 0;
	for ( i=0 ; i<s.length; i++) {
		if ( s.charCodeAt(i) > 255 ) {
			len += 2;
		} else {
			len ++;
		}
	}
	return len;
}

function CheckType(s,spc) {
	var i;
	for(i=0; i<s.length; i++) {
		if (spc.indexOf( s.substring(i, i+1)) < 0) {
			return false;
		}
	}
		
	return true;
}
function CheckLenEng (s, name, nMin, nMax, bIsConsonant) {
	var nStrSize = StringSize(s);
	var cPostN, cPostL;
	
	if (bIsConsonant) {
		cPostL = "";
		cPostN = "";
	} else {
		cPostL = "";
		cPostN = "";
	}
	
	if (nStrSize == 0 && nMin > 0) {
		ERRORMSG = name + cPostL + "  Է ֽʽÿ.";
		return false;
	}
	if (nMin == 0 && nStrSize > nMax) {
		ERRORMSG = name + cPostN + " " + nMax +
			" Ϸ Է ֽʽÿ.\n\n Էµ  : " +
			nStrSize + "";
		return false;
	}
	if (nStrSize < nMin || nStrSize > nMax) {
		ERRORMSG = name + cPostN + " " + nMin +
			" ̻, " + nMax +
			" Ϸ Է ֽʽÿ.\n\n Էµ  : " +
			nStrSize + "";
		return false;
	}
	
	return true;
}
function CheckIDFormat(sUserID){
	if (!CheckType(sUserID, SALPHA+NUM)) {
		ERRORMSG = "[ȸ̵]  ҹڿ ڷ,\n\nù ڴ   ҹڷ ۼؾ մϴ.";
		return false;
	}

	if ( NUM.indexOf(sUserID.charAt(0)) >= 0) {
		ERRORMSG = "[ȸ̵] ù ڴ   ҹڷ ۼؾ մϴ.";
		return false;
	}

	if (sUserID.substring(0,5)=="admin" || sUserID.substring(0,5)=="guest") {
		ERRORMSG = "[ȸ̵] admin, guest    ϴ.";
		return false;
	}
	
	if ( !CheckLenEng(sUserID, "[ȸ̵]", 6, 16, 0) ) {
		return false;
	}

	return true;
}

function CheckPassword (sPass, sRepass) {
	if (!CheckType(sPass, PASSWORD)) {
		ERRORMSG = "[йȣ] , , Ư(! @ . # , $ % ^ * & _ -)\n\n4 ̻ ۼؾ մϴ."
		return false;
	}

	if ( !CheckLenEng(sPass, "[йȣ]", 4, 22, 0) ) {
		return false;
	}

	if (sPass != sRepass) {
		ERRORMSG = "[йȣ] [йȣ Ȯ] ġ ʽϴ.";
		return false;
	}
	
	return true;
}

function CheckEmail (sEmail) {
	if(!sEmail){
		ERRORMSG = " ԷϿ ֽʽÿ.";
		return false;
	}
	if (!CheckType(sEmail, EMAIL)) {
		ERRORMSG = " ߸ ڰ ֽϴ.";
		return false;
	}

	if ( !CheckLenEng (sEmail, "", 0, 64, 0) ) {
		return false;
	}
	
	if ( sEmail == "" ) {
		return true;
	}

	var a = sEmail.indexOf('@');
	if ( a <=0 || a == sEmail.length -1 ) {
		ERRORMSG = " aaa@bbb.ccc.ddd  · Էϼž մϴ.";
		return false;
	}
	
	return true;
}

function CheckAddr () {
	var f = document.sign;
	
	// ڵ ּԷ κ
	if ( f.address2.value != "" && f.address1.value == "" ) {
		ERRORMSG = "[ּ Է] ư Ͽ Է  [ ּ] Է ֽʽÿ.";
		return -1
	}
	
	//  ּԷ κ()
	if (!CheckBAN(f.address2.value, "\"<>")) {
		ERRORMSG = "[ ּ] ߸   <  >  Ȥ  \"   ֽϴ.";
		return -2;
	}
	
	if ( f.address1.value != "" && !CheckLenKr(f.address2.value, "[ ּ]", 1, 128, 0) ) {
		return -2;
	}
	
	return 0;
}

function CheckHomePhonePhone () {
	var f = document.sign;
	var sName = "[ȭȣ]";
	
	// check type
	if (!CheckType(f.ph01.value, NUM)) {
		ERRORMSG = sName + " ߸ ڰ ֽϴ.";
		return 1;
	}
	if (!CheckType(f.ph01.value, NUM)) {
		ERRORMSG = sName + " ߸ ڰ ֽϴ.";
		return 2;
	}
	if (!CheckType(f.ph01.value, NUM)) {
		ERRORMSG = sName + " ߸ ڰ ֽϴ.";
		return 3;
	}
	if(!f.ph01.value){
		ERRORMSG = sName + " ԷϿ ֽʽÿ.";
		return 1;
	}
	if(!f.ph02.value){
		ERRORMSG = sName + " ԷϿ ֽʽÿ.";
		return 2;
	}
	if(!f.ph03.value){
		ERRORMSG = sName + " ԷϿ ֽʽÿ.";
		return 3;
	}

	// length check
	if ( !CheckLenEng(f.ph01.value, sName, 0, 4, 0) ) {
		return 1;
	}
	if ( !CheckLenEng(f.ph01.value, sName, 0, 4, 0) ) {
		return 2;
	}
	if ( !CheckLenEng(f.ph01.value, sName, 0, 4, 0) ) {
		return 3;
	}
	
	return 0;
}

function CheckMobilePhone () {
	var f = document.sign;
	var sName = "[޴]";
	
	if(f.h_ph01.value==0){
		ERRORMSG = sName + " Ͽ ֽʽÿ.";
		return 2;
	}
	
	if (!CheckType(f.h_ph02.value, NUM)) {
		ERRORMSG = sName + " ߸ ڰ ֽϴ.";
		return 2;
	}
	if (!CheckType(f.h_ph03.value, NUM)) {
		ERRORMSG = sName + " ߸ ڰ ֽϴ.";
		return 3;
	}
	if(!f.h_ph02.value){
		ERRORMSG = sName + " ԷϿ ֽʽÿ.";
		return 2;
	}
	if(!f.h_ph03.value){
		ERRORMSG = sName + " ԷϿ ֽʽÿ.";
		return 3;
	}
	
	return 0;
}

function CheckBAN (s,ban) {
	var i;
	if(!s){
		return false;
	}
	for(i=0; i<s.length; i++) {
		if (ban.indexOf( s.substring(i, i+1)) >= 0) {
			return false;
		}
	}

	return true;
}

function CheckLenKr (s, name, nMin, nMax, bIsConsonant) {
	var nStrSize = StringSize(s);
	var cPostN, cPostL;
	
	if (bIsConsonant) {
		cPostL = "";
		cPostN = "";
	} else {
		cPostL = "";
		cPostN = "";
	}
	
	if (nStrSize == 0 && nMin > 0) {
		ERRORMSG = name + cPostL + "  Է ֽʽÿ.";
		return false;
	}
	if (nMin == 0 && nStrSize > nMax) {
		ERRORMSG = name + cPostN + " ѱ " + Math.floor(nMax/2) +
			" Ϸ Է ֽʽÿ.\n\n Էµ  : " +
			nStrSize/2 + "";
		return false;
	}
	if (nStrSize < nMin || nStrSize > nMax) {
		ERRORMSG = name + cPostN + " ѱ " + Math.ceil(nMin/2) +
			" ̻, " + Math.floor(nMax/2) +
			" Ϸ Է ֽʽÿ.\n\n Էµ  : " +
			nStrSize/2 + "";
		return false;
	}
	
	return true;
}
function CheckRID (sRIDFirst, sRIDLast) {
	var chk = 0;
	
	var nYear = sRIDFirst.substring(0,2);
	var nMondth = sRIDFirst.substring(2,4);
	var nDay = sRIDFirst.substring(4,6);
	
	var nSex = sRIDLast.charAt(0);

	if (!CheckType(sRIDFirst, NUM)) {
		ERRORMSG = "[ֹεϹȣ պκ] ߸ ڰ ֽϴ.";
		return -1;
	}
	
	if ( sRIDFirst.length!=6 ||  nMondth<1 || nMondth>12 || nDay<1 || nDay>31) {
		ERRORMSG = "[ֹεϹȣ պκ] ߸Ǿϴ.";
		return -1;
	}
	
	if (!CheckType(sRIDLast, NUM)) {
		ERRORMSG = "[ֹεϹȣ ޺κ] ߸ ڰ ֽϴ.";
		return 1;
	}
	
	if ( sRIDLast.length!=7 || (nSex!=1 && nSex!=2 && nSex!=3 && nSex!=4) ) {
		ERRORMSG = "[ֹεϹȣ ޺κ] ߸Ǿϴ.";
		return 1;
	}
	
	var i;

	for (i=0; i<6; i++) {
		chk += ( (i+2) * parseInt( sRIDFirst.charAt(i) ));
	}
	
	for (i=6; i<12; i++) {
		chk += ( (i%8+2) * parseInt( sRIDLast.charAt(i-6) ));
	}
	
	chk = 11 - (chk%11);
	chk %= 10;
	
	if (chk != parseInt( sRIDLast.charAt(6))) {
		ERRORMSG = "ȿ  [ֹεϹȣ]Դϴ.";
		return -1;
	}
	
	return 0;
}

function checkSign(){	
	var f=document.sign;	
	if (!CheckIDFormat (f.id.value)) {	
		alert (ERRORMSG);
		f.id.focus();
		return false;
	}
	
	// check passwd
	if ( !CheckPassword (f.password.value, f.re_password.value) ) {
		alert (ERRORMSG);
		f.password.focus();
		return false;
	}
	
	// check riddle
	if (!CheckBAN(f.q_password.value, "\"<>")) {
		alert("[йȣ ã ] ߸   <  >  Ȥ  \"   ֽϴ.");
		f.q_password.focus();
		return false;
	}
	
	if ( !CheckLenKr(f.q_password.value, "[йȣ ã ]", 0, 64, 0) ) {
		alert (ERRORMSG);
		f.q_password.focus();
		return false;
	}
	
	if (!CheckBAN(f.a_password.value, "\"<>")) {
		alert("[йȣ ã ] ߸   <  >  Ȥ  \"   ֽϴ.");
		f.a_password.focus();
		return false;
	}
	
	if ( !CheckLenKr(f.a_password.value, "[йȣ ã ]", 0, 32, 1) ) {
		alert (ERRORMSG);
		f.a_password.focus();
		return false;
	}
	
	if (!CheckBAN(f.name.value, "\"<>" + ALPHA + NUM)) {
		alert("[ѱ ̸] ѱ۷ Է ֽʽÿ.");
		f.name.focus();
		return false;
	}
	
	if ( !CheckLenKr(f.name.value, "[ѱ ̸]", 2, 32, 1) ) {
		alert (ERRORMSG);
		f.name.focus();
		return false;
	}
	
	ret = CheckRID (f.rano1.value, f.rano2.value);
	if ( ret != 0 ) {
		alert(ERRORMSG);
		if ( ret < 0) {
			f.rano1.focus();
		} else {
			f.rano2.focus();
		}
		return false;
	}
	
	if ( !CheckEmail (f.mail.value) ) {
		ERRORMSG = "[ ּ]" + ERRORMSG;
		alert (ERRORMSG);
		f.mail.focus();
		return false;
	}
	
	ret = CheckAddr ();
	if ( ret != 0 ) {
		alert (ERRORMSG);
		switch (ret) {
		case -1:
			f.address1.focus();
			break;
		case -2:
			f.address2.focus();
			break;
		}
		return false;
	}
	
	ret = CheckHomePhonePhone();
	if ( ret != 0 ) {
		alert (ERRORMSG);
		switch (ret) {
		case 1:
			f.ph01.focus();
			break;
		case 2:
			f.ph02.focus();
			break;
		case 3:
			f.ph03.focus();
			break;
		}
		return false;
	}
	
	ret = CheckMobilePhone();
	if ( ret != 0 ) {
		alert (ERRORMSG);
		switch (ret) {
		case 2:
			f.h_ph02.focus();
			break;
		case 3:
			f.h_ph03.focus();
			break;
		}
		return false;
	}
	
	var s = f.rano2.value.substring(0,1);
	if (s==1 || s==3) {
		f.gender.value = "M";
	}
	
	if (s==2 || s==4) {
		f.gender.value = "F";
	}
	return true;
}

function checkId(){
	var f=document.sign;
	
	if (!CheckIDFormat (f.id.value)) {	
		alert (ERRORMSG);
		f.id.focus();
		return false;
	}
		
	window.open('member_join_search_id.php?id='+f.id.value,'IdCheck','width=300,height=200');
}

function checkNick(){
	var f=document.sign;
	
	if(!f.nickname.value){
		alert('г ԷϿ ֽʽÿ');
		f.nickname.focus();
		return false;
	}
		
	window.open('member_join_search_nickname.php?nickname='+f.nickname.value,'IdCheck','width=300,height=200');
}
function checkRano(){
	var f=document.sign;
	
	ret = CheckRID (f.rano1.value, f.rano2.value);
	if ( ret != 0 ) {
		alert(ERRORMSG);
		if ( ret < 0) {
			f.rano1.focus();
		} else {
			f.rano2.focus();
		}
		return false;
	}
		
	window.open('rano_check.php?rano1='+f.rano1.value+'&rano2='+f.rano2.value,'RanoCheck','width=400,height=240');
}